首页 > 代码库 > LeetCode Problem 2:Two Sum
LeetCode Problem 2:Two Sum
描述:
Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
思路1:暴力搜索,两层循环。时间:O(n^2),空间:O(1),可能出现超时
思路2:考虑使用map或者hash_map,遍历输入的numbers,在map映射表中寻找target-numbers[i],C++ STL中map使用红黑树实现,查找元素时间O(logn),总时间O(nlogn)
1 class Solution { 2 public: 3 vector<int> twoSum(vector<int> &numbers, int target) { 4 5 vector<int> result; 6 map<int, int> hashMap; 7 8 for(int i = 0; i < numbers.size(); i++) { 9 10 if(!hashMap.count(numbers[i])) 11 hashMap.insert(pair<int,int>(numbers[i], i)); // <value, key>12 13 if(hashMap.count(target - numbers[i])) {14 int n = hashMap[target - numbers[i]]; //get the second number‘s position15 if(n < i) {16 result.push_back(n + 1);17 result.push_back(i + 1);18 return result;19 }20 21 //unnecessary22 /*if(n > i) {23 result.push_back(i + 1);24 result.push_back(n + 1);25 return result;26 }*/27 }28 }29 }30 };
附LeetCode建议解决方案
LeetCode Problem 2:Two Sum
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。